#ifndef foorulesethfoo
#define foorulesethfoo

#include <glib.h>
#include <gtk/gtk.h>
#include "ruleset.h"

#include "../daemon/common.h"
#include "main.h"
#include "connection.h"

typedef enum broadcast_match { BCM_DONT_MATCH, BCM_MATCH_BROADCAST, BCM_MATCH_UNICAST } broadcast_match_t;

typedef struct rule {
    gboolean realized;
    gboolean enabled;

    verdict_t verdict;
    
    char description[64];
    char device_in[IFNAMSIZ+1];
    char device_out[IFNAMSIZ+1];
    conn_direction_t direction;
    guint protocol;
    guint port;
    guint icmp_type;
    guint32 src_ip_address;
    guint src_netmask_bits;
    guint32 dst_ip_address;
    guint dst_netmask_bits;
    broadcast_match_t broadcast;

    guint32 id;
    GtkTreeIter iter;
} rule_t;

extern gboolean ruleset_modified;
extern gchar* ruleset_file;



int ruleset_load(gchar *fn);
int ruleset_save(gchar *fn);
int ruleset_commit();
int ruleset_append_rule(rule_t *rule);
int ruleset_update_rule(rule_t *rule);
int ruleset_remove_rule(rule_t *rule);
void ruleset_free();

void ruleset_widget_init();

rule_t* rule_new();
rule_t* rule_new_from_conn_info(conn_info_t *ci);
#define rule_free(rule) g_free(rule)


#endif
